#include <stdio.h>
#include "cgi-lib.h" /* include the cgi-lib.h header file */
#include "html-lib.h" /* include the html-lib.h header file */
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <crypt.h>

#define FTP_DENY 1  /* comment for http://* only */

/* #define CHDIR_NAME       "/tmp/" */
#define CHDIR_NAME       "/usr/local/squid/etc/"

/* #define ADD_CFG 1 */

#ifndef ADD_CFG
char redir_include_cfg[]= CHDIR_NAME"rdr_inc.cfg";
#else /* #define ADD_CFG 1 */
char redir_include_cfg[]= CHDIR_NAME"rdr_inc_add.cfg";
#endif

#ifndef ADD_CFG
char P_all[] = "P_all";
#else
char P_all[] = "P_all_add";
#endif

#ifndef ADD_CFG
char pass[] = "IHY90tEacQrVk"; /* crypt("cgi-redir","IH"); */
#else
char pass[] = "IHn72HoeUz162"; /* crypt("cgi2-redir","IH"); */
#endif


#ifdef FTP_DENY
char U_cmd1[] = "U http://* $MYH/deny_traf.html";
char U_cmd2[] = "U ftp://* $MYH/deny_traf.html";
#else
char U_cmd1[] = "U * $MYH/deny_traf.html";
#endif

struct TIME_TYPES {
	char * value;
	char * msg;
	int  type;
	};

struct TIME_TYPES time_types[] = {
#include "time_acls.h"
	{ 0, 0, 0 }
	};


#define R_RD 0
#define D_RD 1

char *msg_RD[2] = { "", "" };



void * my_alloc(unsigned int u) {
void * pa;

pa = malloc(u);
if(pa == 0)
	printf("  \n");
return pa;
}

struct CFG_LIST {
	char * name;
	char * ip_mask;
	int    acl_rd;
	int    time_acces;
	struct CFG_LIST *next;
	};

struct CFG_LIST *top = 0;

int acl_add(int type, const char *name, char *ip_mask, char *time) {
struct CFG_LIST *cur;
struct CFG_LIST *cur2;
int i;

for(cur2 = top; cur2 != 0; cur2 = cur2->next)
	if(!strcmp(name, cur2->name)) {
		printf("Acl %s allready", name);
		return -1;
		}
cur = my_alloc(sizeof(struct CFG_LIST));
if(cur == 0)
	return -1;
cur->next = 0;
cur->ip_mask = strcpy(my_alloc(strlen(ip_mask)+1), ip_mask);
if(cur->ip_mask == 0)
	return -1;
cur2 = top;
if(top) {
	while(cur2->next != 0) cur2 = cur2->next;
	cur2->next = cur;
	}
 else
	top = cur;
cur->name = strcpy(my_alloc(strlen(name)+1), name);
if(cur->name == 0)
    return -1;
for(i = 0; time_types[i].type != 0; i++)
	if(strcmp(time, time_types[i].value)==0)
		break;
if(time_types[i].type==0) {
	printf("Bad time format while setup acl %s", name);
	return -1;
	}
cur->time_acces = time_types[i].type;
cur->acl_rd = type=='R' ? R_RD : D_RD;
return 0;
}

int strip_space(char *s, int size) { /*   -    */
register char *s2;
register char *s3;

if(size<=0) return 0;
s2 = s+size;
if(*(s2-1) != '\n')
	*s2++ = '\n'; /*      */
*s2 = 0;
s2 = s;
while( *s2 ) {
	if( *s2 == '#' ) { /*   */
		s3 = s2;
		while( *++s3 != '\n' );
		strcpy(s2, s3);
		}
	 else if( *s2 == '\t' ) *s2 = ' '; /*  \t   */
	 else if( *s2 == '\\' && *(s2+1) == '\n' ) {
		/*    : \\n */
		*s2++ = ' '; *s2 = ' ';
		}
	s2++;
	}
s2 = s;    /*  \n      */
while( *s2 == ' ' || *s2 == '\n' ) s2++;
s2 = strcpy(s, s2);
while( *s2 ) {  /*       */
	if(*s2 == ' ' && (*(s2+1) == ' ' || *(s2+1) == '\n')) {
		s3 = s2+2;
		while( *s3 == ' ' || *s3 == '\n' ) s3++;
		strcpy(s2, s3-1);
		}
	 else if(*s2 == '\n' && (*(s2+1) == ' ' || *(s2+1) == '\n')) {
		s3 = s2+2;
		while( *s3 == ' ' || *s3 == '\n' ) s3++;
		strcpy(s2+1, s3);
		}
	 else
		s2++;
	}
return (int)((unsigned char)*s);
}

static char *get_parm(char *s, int delim1, int delim2, char *sdelim) {
while( *s != ' ' && *s != '\n' && *s != 0 ) s++;
if( *s != delim1 && *s != delim2) return 0;
if(sdelim)
	*sdelim = *s;
*s++ = 0;
return s;
}

int read_ub(const char *ncfg) {
struct stat statb;
int n, f;
char *s, *sold, *rs, *an;
char delim;
char *allocate1, *allocate2;

if(stat(ncfg, &statb)<0) {
	printf("Can`t stat cfg_file %s", ncfg);
	return 0;
	}
s = my_alloc(statb.st_size+2);
if(s==0)
	return 0;
allocate1 = s;
f = open(ncfg, O_RDONLY);
if(f<0) {
	printf("Can`t open cfg_file %s", ncfg);
	return 0;
	}
n = read(f, s, statb.st_size);
#ifdef unix
if(n!=statb.st_size) {
	printf("Error reading cfg_file");
	return 0;
	}
#endif
close(f);
if(!strip_space(s, n)) {
erp:
	printf("Error parsing cfg_file");
	return 0;
	}
allocate2 = my_alloc(strlen(s)+1);
if(allocate2 == 0)
	return 0;
strcpy(allocate2, s);
free(allocate1);
allocate1 = s = allocate2;
n = 0;   /*   */
while( *s ) {
	f = *s++;                              /*  */
	f &= 0337;
	if(f!='D' && f!='R' && f!='P' && f!='U')
		goto erp;
	if( *s != ' ' ) goto erp;
	sold = ++s;
	rs = get_parm(s, ' ', ' ', 0);
	if( rs == 0 ) goto erp;
	an  = get_parm(rs, '\n', ' ', &delim);
	if( an  == 0 ) goto erp;
	if(delim==' ') {
		s  = get_parm(an, '\n', '\n', 0);
		if( s  == 0 ) goto erp;
		}
	 else
		s = an;
	if(f=='D' || f=='R') {
	    if(delim=='\n')
		an = "*";
	    if(acl_add(f, sold, rs, an))
		return 0;
	    n++;
	    }
	}
if(!n)
	printf("Error: parser config returned empty");
free(allocate1);
return n;
}

/* #define DEBUG 1 */

#ifdef DEBUG
#define debug(dmsg) printf("DEBUG: %s\n", dmsg)
#else
#define debug(dmsg)
#endif

void parse_cgi_in(LIST *head, int i) {
struct CFG_LIST *cur2;
int er = 0;
int rd;
int t;
int j;
char buf_str_val[64];
char *val;

top = my_alloc(i*sizeof(struct CFG_LIST));
if(top!=0) {
    cur2 = top;
    for(j=0;j<i;j++) {
	sprintf(buf_str_val, "X%d", j);
	buf_str_val[0] = 'c';
	val = find_val(head, buf_str_val);
	if(val==NULL) { er++; debug("1"); continue; }
	cur2->name = val;
	buf_str_val[0] = 'm';
	val = find_val(head, buf_str_val);
	if(val==NULL) { er++; debug("2"); continue; }
	cur2->ip_mask = val;
	buf_str_val[0] = 'a';
	val = find_val(head, buf_str_val);
	if(val==NULL) { er++; debug("3"); continue; }
	rd = atoi(val);
	if(rd!=R_RD && rd!=D_RD) { er++; debug("4"); continue; }
	cur2->acl_rd = rd;
	buf_str_val[0] = 'u';
	val = find_val(head, buf_str_val);
	if(val==NULL) { er++; debug("5"); continue; }
	t = atoi(val);
	for(rd=0; time_types[rd].type != 0; rd++)
	    if(t==time_types[rd].type) break;
	if(time_types[rd].type == 0) { er++; debug("6"); continue; }
	if(cur2->acl_rd == D_RD && t != 1) { /*  */
		h2("   `'    ");
		printf("<BR> %s ", cur2->name);
		h3("   `'");
		t = 1;
		}
	cur2->time_acces = t;
	if((j+1)!=i) {
	    cur2->next = &top[j+1];
	    cur2 = cur2->next;
	    }
	}
    if(er) {
	printf("Error parse input data\n");
	free(top);
	top = 0;
	}
     else
	cur2->next = 0;
    }
}

void rewrite_cfg(void) {
FILE *out;
int n,t;
struct CFG_LIST *cur2;

out = fopen(redir_include_cfg, "w");
if(out==NULL)
    h2("Can`t rewrite config file");
 else {
    for(cur2 = top; cur2 != 0; cur2 = cur2->next) {
	for(t=0;time_types[t].type != 0; t++)
	    if(cur2->time_acces==time_types[t].type)
		break;
	fprintf(out, "%c %s %s %s\n", (cur2->acl_rd==R_RD?'R':'D'),
					cur2->name, cur2->ip_mask,
					time_types[t].value);
	}
    n = 0;
    for(cur2 = top; cur2 != 0; cur2 = cur2->next)
	if(cur2->acl_rd!=D_RD)
		n++;
    if(n==1) {
	for(cur2 = top; cur2 != 0; cur2 = cur2->next)
		if(cur2->acl_rd!=D_RD)
			break;
	fprintf(out, "%s %s\n", U_cmd1, cur2->name);
#ifdef FTP_DENY
	fprintf(out, "%s %s\n", U_cmd2, cur2->name);
#endif
	}
    if(n>1) {
	fprintf(out, "P %s", P_all);
	n = 0;
	for(cur2 = top; cur2 != 0; cur2 = cur2->next)
	    if(cur2->acl_rd!=D_RD) {
		fprintf(out, "%c%s", (n!=0 ? '+' : ' '), cur2->name);
		n++;
		}
	fprintf(out, "\n");
	fprintf(out, "%s %s\n", U_cmd1, P_all);
#ifdef FTP_DENY
	fprintf(out, "%s %s\n", U_cmd2, P_all);
#endif
	}
    fclose(out);
    }
}

int main() {

LIST *head = 0;
struct CFG_LIST *cur2;
int i,j;
char *val;
char *pas;

head = cgi_input_parse();
mime_header("text/html");

html_begin(" ",
	   "HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=koi8-r\"",
	   NULL);
h1(" ");
printf("<BR><BR>\n");
if(head == NULL) {
bad_pas:
    h3("   !");
lerr:
    printf("<BR><HR>\n");
    html_end();
    return 0;
    }
val = find_val(head, "pass");
if(val==NULL)
	goto bad_pas;
pas = strcpy(my_alloc(strlen(val)+1), val);
val = crypt(val,"IH");
if(strcmp(pass, val)) {
    h3(" ");
    goto lerr;
    }
val = find_val(head, "i");
if(val!=NULL) {
    i = atoi(val);
    if(i>0) {
	parse_cgi_in(head, i);
	if(top) {
	    rewrite_cfg();
	    free(top);
	    top = 0;
	    }
	 else goto lerr;
	}
     else goto lerr;
    }
if(read_ub(redir_include_cfg)!=0) {
#ifndef ADD_CFG
    printf("<FORM ACTION=\"/cgi-bin/cgi-redir\" METHOD=\"POST\">\n");
#else
    printf("<FORM ACTION=\"/cgi-bin/cgi-redir-add\" METHOD=\"POST\">\n");
#endif
    printf("<TABLE>\n<TR><TD><B>:</B></TD>\n");
    printf("<TD><INPUT NAME=\"pass\" SIZE=15 VALUE=\"%s\" TYPE=\"password\"></TD></TR>\n", pas);
    printf("</TABLE><BR><HR><BR>\n");
    printf("<TABLE><TR><TD><B></B></TD><TD></TD><TD></TD></TR>\n");
    for(i=0, cur2 = top; cur2 != 0; cur2 = cur2->next, i++) {
	printf("<TR><TD><B>%s</B></TD>\n", cur2->name);
	printf("<INPUT TYPE=\"hidden\" NAME=\"c%d\" VALUE=\"%s\">\n",
	    i, cur2->name);
	printf("<INPUT TYPE=\"hidden\" NAME=\"m%d\" VALUE=\"%s\">\n",
	    i, cur2->ip_mask);
	printf("<TD><select NAME=\"a%d\" SIZE=\"1\">\n", i);
	printf("<option VALUE=\"%d\" %s>%s\n", R_RD,
	    (cur2->acl_rd==R_RD?"Selected":""), msg_RD[R_RD]);
	printf("<option VALUE=\"%d\" %s>%s\n", D_RD,
	    (cur2->acl_rd==D_RD?"Selected":""), msg_RD[D_RD]);
	printf("</select></TD><TD><select NAME=\"u%d\" SIZE=\"1\">\n", i);
	for(j = 0; time_types[j].type != 0; j++)
	    printf("<option VALUE=\"%d\" %s>%s\n", time_types[j].type,
		(cur2->time_acces==time_types[j].type?"Selected":""),
		time_types[j].msg);
	printf("</select></TD></TR>\n");
	}
    printf("<INPUT TYPE=\"hidden\" NAME=\"i\" VALUE=\"%d\">\n", i);
    printf("</TABLE>\n");
    printf("<INPUT TYPE=\"submit\" VALUE=\"\">\n");
    }
goto lerr;
}
